// Copyright (c) 2023 VMware Carbon Black, all rights reserved

package config

import (
	"context"

	"github.com/aws/aws-sdk-go-v2/config"
	"github.com/aws/aws-sdk-go-v2/service/kinesis"
)

func CreateKinesisClient(conf *Config) (*kinesis.Client, error) {
	awsConfig, err := config.LoadDefaultConfig(context.TODO(),
		config.WithRegion(conf.Region),
	)
	if err != nil {
		return nil, err
	}
	return kinesis.NewFromConfig(awsConfig, func(o *kinesis.Options) {
		if conf.IsLocalEnv() {
			o.BaseEndpoint = &conf.AwsEndpoint
			o.Region = conf.Region
		}
	}), err
}
