package logger

import (
	. "github.com/onsi/ginkgo/v2"
	. "github.com/onsi/gomega"
	"go.uber.org/zap"
)

type mockTester struct {
	toRet bool
}

func (m *mockTester) Test(data []byte) bool {
	return m.toRet
}

func (m *mockTester) Add(data []byte) {
}

var _ = Describe("filtered logger test suite", func() {
	It("logs when it should", func() {
		testZapLogger := nopStopLogger(zap.NewNop())
		testFilterLogger := newBloomedLogger(testZapLogger, &mockTester{toRet: false})
		outputLogger := testFilterLogger.IfNotSeen([]byte("foobar"))
		Expect(outputLogger == testZapLogger).To(BeTrue())
	})
	It("does not logswhen it should not", func() {
		testZapLogger := nopStopLogger(zap.NewNop())
		testFilterLogger := newBloomedLogger(testZapLogger, &mockTester{toRet: true})
		outputLogger := testFilterLogger.IfNotSeen([]byte("foobar"))
		Expect(outputLogger == testZapLogger).To(BeFalse())
	})
})
