<!--suppress CssUnusedSymbol -->
<style>
  .blue { color: dodgerblue; }
  .op {  border-bottom: thin solid grey; font-family: monospace; color: chocolate; margin-left:25px; width: fit-content}
  .sep { height: 2px; border-width: 0; background-color: goldenrod; }
  .text { padding: 2px 3px 2px 3px; border: thin dotted white; background-color: black; color: cadetblue; margin-left:25px;  width: fit-content}
  h1 { color: chocolate; }
</style>
# Metrics


Monitored metrics of `hello-api` include these categories:
* Golang System Metrics

## Dimensions
EMS device-hello have dimensions that are broken up into 2 categories:
* Application Tags
* Metric-dependent Dimensions

The application tags are further broken down as the following:
* `Application`: psc
* `Service`: ems-device-hello

Instance is included when instantiating a reporter as its `Source`, and is a unique identifier to distinguish the instance reporting.

## RED Metrics
In Wavefront, RED metrics are key indicators of the health of your service, and are used to discover problem traces.
Our RED metrics tag keys are:
* `http.status_code`
* `http.user_agent`
* `http.cache_hit`

## Monitoring Health:
There are 2 main ways we monitor the health of requests:
1. **Request rate and latency.** Total requests made over time are summed and visualized as an area. Latency is shown as a histogram and 95th percentile duration. If our latency starts to creep up, it may indicate that we need to scale, and should ensure that our max replicas are set correctly.
2. **Requests made per minute.** Knowing the current load on hello will give us insight on performance in relation to scale.

### Enforcement
With Enforcement mode, we want to be able to ensure our uptime is high, latency is low and errors aren't outside the normal range. 

## Kubernetes Provided Metrics
currently running pods is a metric provided for free from mosaic.

## Hello Customized Metric
* `kpl.hello-lct-stream.failed` - This metric represents the number of publishing failures to lct kinesis stream