// Copyright (c) 2023 VMware Carbon Black, all rights reserved

package metrics

import (
	"log"

	. "github.com/onsi/ginkgo/v2"
)

var _ = Describe("Metrics Unit Tests", func() {
	Context("Go Stats Testing", func() {
		It("Default Stat", func() {
			gsm := goStatGaugeMetric{}
			log.Printf("default = %d", gsm.Value())
		})

		// NOTE: For these tests we can't prove numbers since they can be anything -- we are just making sure they all work

		It("validates alloc", func() {
			gsm := goStatGaugeMetric{stat: alloc}
			log.Printf("alloc = %d", gsm.Value())
		})
		It("validates totalAlloc", func() {
			gsm := goStatGaugeMetric{stat: totalAlloc}
			log.Printf("totalAlloc = %d", gsm.Value())
		})
		It("validates sys", func() {
			gsm := goStatGaugeMetric{stat: sys}
			log.Printf("sys = %d", gsm.Value())
		})
		It("validates lookups", func() {
			gsm := goStatGaugeMetric{stat: lookups}
			log.Printf("lookups = %d", gsm.Value())
		})
		It("validates mallocs", func() {
			gsm := goStatGaugeMetric{stat: mallocs}
			log.Printf("mallocs = %d", gsm.Value())
		})
		It("validates frees", func() {
			gsm := goStatGaugeMetric{stat: frees}
			log.Printf("frees = %d", gsm.Value())
		})
		It("validates heapAlloc", func() {
			gsm := goStatGaugeMetric{stat: heapAlloc}
			log.Printf("heapAlloc = %d", gsm.Value())
		})
		It("validates heapSys", func() {
			gsm := goStatGaugeMetric{stat: heapSys}
			log.Printf("heapSys = %d", gsm.Value())
		})
		It("validates heapIdle", func() {
			gsm := goStatGaugeMetric{stat: heapIdle}
			log.Printf("heapIdle = %d", gsm.Value())
		})
		It("validates heapInUse", func() {
			gsm := goStatGaugeMetric{stat: heapInUse}
			log.Printf("heapInUse = %d", gsm.Value())
		})
		It("validates heapReleased", func() {
			gsm := goStatGaugeMetric{stat: heapReleased}
			log.Printf("heapReleased = %d", gsm.Value())
		})
		It("validates heapObjects", func() {
			gsm := goStatGaugeMetric{stat: heapObjects}
			log.Printf("heapObjects = %d", gsm.Value())
		})
		It("validates stackInUse", func() {
			gsm := goStatGaugeMetric{stat: stackInUse}
			log.Printf("stackInUse = %d", gsm.Value())
		})
		It("validates stackSys", func() {
			gsm := goStatGaugeMetric{stat: stackSys}
			log.Printf("stackSys = %d", gsm.Value())
		})
		It("validates mSpanInUse", func() {
			gsm := goStatGaugeMetric{stat: mSpanInUse}
			log.Printf("mSpanInUse = %d", gsm.Value())
		})
		It("validates mSpanSys", func() {
			gsm := goStatGaugeMetric{stat: mSpanSys}
			log.Printf("mSpanSys = %d", gsm.Value())
		})
		It("validates mCacheInUse", func() {
			gsm := goStatGaugeMetric{stat: mCacheInUse}
			log.Printf("mCacheInUse = %d", gsm.Value())
		})
		It("validates mCacheSys", func() {
			gsm := goStatGaugeMetric{stat: mCacheSys}
			log.Printf("mCacheSys = %d", gsm.Value())
		})
		It("validates buckHashSys", func() {
			gsm := goStatGaugeMetric{stat: buckHashSys}
			log.Printf("buckHashSys = %d", gsm.Value())
		})
		It("validates gcSys", func() {
			gsm := goStatGaugeMetric{stat: gcSys}
			log.Printf("gcSys = %d", gsm.Value())
		})
		It("validates otherSys", func() {
			gsm := goStatGaugeMetric{stat: otherSys}
			log.Printf("otherSys = %d", gsm.Value())
		})
		It("validates pauseTotalNS", func() {
			gsm := goStatGaugeMetric{stat: pauseTotalNS}
			log.Printf("pauseTotalNS = %d", gsm.Value())
		})
		It("validates nextGC", func() {
			gsm := goStatGaugeMetric{stat: nextGC}
			log.Printf("nextGC = %d", gsm.Value())
		})
		It("validates lastGC", func() {
			gsm := goStatGaugeMetric{stat: lastGC}
			log.Printf("lastGC = %d", gsm.Value())
		})
		It("validates numGC", func() {
			gsm := goStatGaugeMetric{stat: numGC}
			log.Printf("numGC = %d", gsm.Value())
		})
		It("validates numCGOCall", func() {
			gsm := goStatGaugeMetric{stat: numCGOCall}
			log.Printf("numCGOCall = %d", gsm.Value())
		})
		It("validates numGoRoutine", func() {
			gsm := goStatGaugeMetric{stat: numGoRoutine}
			log.Printf("numGoRoutine = %d", gsm.Value())
		})
	})
})
