// Copyright (c) 2023 VMware Carbon Black, all rights reserved

package wavefront

import (
	"time"
)

// TrackMethodTime records the duration of a method
func (c *Reporter) TrackMethodTime(metricName string, start time.Time, dims map[string]string) {
	c.Histogram(
		metricName+".duration.micros",
		dims,
		time.Since(start).Nanoseconds()/1e3,
	)
}
