// Copyright (c) 2023 VMware Carbon Black, all rights reserved

package utils

import (
	"fmt"
)

// HeaderStr -- Create a test header banner that makes it easier to pick out tests in the log.
func HeaderStr(tag string) string {
	p := padding(tag)
	return fmt.Sprintf("===== %s %s", tag, p)
}

// padding -- Generate header/trailer banner fill
func padding(tag string) string {
	useLen := 80 - (len(tag) + 7)
	if useLen < 5 {
		useLen = 5
	}
	b := make([]byte, useLen)
	for i := range b {
		b[i] = '='
	}
	return string(b)
}
